/***********************************************************************************/
// Projet Monica :Rception de trames HF  433MHz
/***********************************************************************************/
#include <p18cxxx.h>
#define  USE_AND_MASKS
#include <pconfig.h>	// choix des fonctions en fonction du type de pic
#include <delays.h>
#include <stdio.h>
#include <timers.h>		// Timers
#include <usart.h>		// RS232
#include <portb.h>		// Interruptions Externes
#include "HardwareProfile.h"					
#pragma config OSC = INTIO67	// horloge interne
//#pragma config OSC = HS		// horloge externe

#pragma config WDT=OFF			// whatch dog
/************************************************************************************/
#define L1 PORTAbits.RA0
#define L2 PORTAbits.RA1
#define L3 PORTAbits.RA2
#define L4 PORTAbits.RA3
#define L5 PORTAbits.RA4
#define L6 PORTAbits.RA5
#define L7 PORTAbits.RA6
#define L8 PORTAbits.RA7

#define C0 PORTCbits.RC0
#define C1 PORTCbits.RC1
#define C2 PORTCbits.RC2
#define C3 PORTCbits.RC3
/************************************************************************************/
void Setup(void)
{
	TRISC=0xf0;			// Port C en entre et sortie
	TRISA=0;			// Port A en Sortie
	OSCCON=0x70;		// 0 111 00 0 00pas de prdiviseur => 8MHz horloge interne
	ADCON1=0x0f;		// Tout digital	
	PORTA=0;			// Toutes les leds off

// Transmission RS232 600b/s

	OpenUSART( 	USART_TX_INT_OFF  &
            	USART_RX_INT_OFF  &
            	USART_ASYNCH_MODE &		// mode asynchrone
            	USART_EIGHT_BIT   &		// 8bits
            	USART_CONT_RX     &		// 600b/s
				USART_BRGH_LOW,207);  	// [(8000000/600b/s)/64]-1	si hrl int 8MHz	
}									
/*******************************************************************************************/
void main(void)
{
	unsigned char tab[15];
	unsigned char car;			// caractre reu sur rs232
	unsigned char i;			// index tab
	unsigned char j;			// nb oct identiques
	unsigned char k;
	unsigned char l;
	unsigned char m;
	unsigned char n;
	unsigned char q;
	unsigned char p;
	unsigned char r;
	unsigned char s;
	unsigned char o;
	Setup();
	for(;;)
	{
		for(i=0;i<15;i=i+1)tab[i]=0;
		car=0;
		do
		{
			while (!DataRdyUSART());		// Detection de debut de trame 01
			car=ReadUSART();
		}
		while (car!=1);
		i=0;
		do									// Reception de la trame
		{		
			while (!DataRdyUSART());
			tab[i]=ReadUSART();
			i=i+1; 
		}
		while (tab[i-1]!=0xd);				// Detection fin de trame 0D

		j=0;k=0;l=0;m=0;p=0;q=0;r=0;s=0;o=0;
		for(i=0;i<11;i=i+1)					// Decodage trame
		{
			if (tab[i]==0x41) j=j+1;		// Pivot Gauche
			if (tab[i]==0x42) k=k+1;		// Avant Rapide
			if (tab[i]==0x43) l=l+1;		// Pivot Droit
			if (tab[i]==0x34) m=m+1;		// Rotation Gauche
			if (tab[i]==0x32) p=p+1;		// Avant Lent
			if (tab[i]==0x35) q=q+1;		// Rotation Droite
			if (tab[i]==0x33) r=r+1;		// Arriere
			if (tab[i]==0x45) s=s+1;		// 2
			if (tab[i]==0x31) o=o+1;		// Arret
		}
		// Test si 3 caracteres recus identiques
	 	// Scurisation de la transmission

		if(o>=3) {PORTA=0;C3=1;C2=1;C1=1;C0=1;}									// F
		if(j>=3) {L1=1;L2=0;L3=0;L4=0;L5=0;L6=0;L7=0;L8=0;C3=1;C2=1;C1=1;C0=0;}	// E	
		if(k>=3) {L1=0;L2=1;L3=0;L4=0;L5=0;L6=0;L7=0;L8=0;C3=1;C2=1;C1=0;C0=1;}	// D				
		if(l>=3) {L1=0;L2=0;L3=1;L4=0;L5=0;L6=0;L7=0;L8=0;C3=1;C2=1;C1=0;C0=0;}	// C
		if(m>=3) {L1=0;L2=0;L3=0;L4=1;L5=0;L6=0;L7=0;L8=0;C3=1;C2=0;C1=1;C0=1;}	// B
		if(p>=3) {L1=0;L2=0;L3=0;L4=0;L5=1;L6=0;L7=0;L8=0;C3=1;C2=0;C1=1;C0=0;}	// A
		if(q>=3) {L1=0;L2=0;L3=0;L4=0;L5=0;L6=1;L7=0;L8=0;C3=1;C2=0;C1=0;C0=1;}	// 9
		if(r>=3) {L1=0;L2=0;L3=0;L4=0;L5=0;L6=0;L7=1;L8=0;C3=1;C2=0;C1=0;C0=0;}	// 8
		if(s>=3) {L1=0;L2=0;L3=0;L4=0;L5=0;L6=0;L7=0;L8=1;C3=0;C2=1;C1=1;C0=1;}	// 7	
	}
}	
/***********************************************************************************/





